
; CC5X Version 3.2I, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  29. Jun 2006  16:06  *************

	processor  12F629
	radix  DEC

	__config 0x2184

Zero_       EQU   2
RP0         EQU   5
GIE         EQU   7
OPTION_REG  EQU   0x81
GPIO        EQU   0x05
CMCON       EQU   0x19
TRISIO      EQU   0x85
OSCCAL      EQU   0x90
RED         EQU   0
YELLOW      EQU   1
GREEN       EQU   2
PED_GREEN   EQU   4
PED_RED     EQU   3
aTs         EQU   0x21
i           EQU   0x22
aTs_2       EQU   0x7F
aTs_3       EQU   0x20

	GOTO main

  ; FILE Svetofor.c
			;/*
			;
			;
			;;                  ---------
			;;               5V |1     8| 0V
			;;         BUZZ GP5 |2     7| GP0 -> RED
			;;    PED.GREEN GP4 |3     6| GP1 -> YELLOW
			;;      PED.RED GP3 |4     5| GP2 -> GREEN
			;;                  ---------
			;
			;*/
			;
			;#include "12F629.H" 
			;
			;//--- PORT DEFINITIONS ---------------------------------------------------
			;//               76543210
			;#define  TrisA 0b00000000                
			;//               ||||||||
			;//               |||||||RED
			;//               ||||||YELLOW
			;//               |||||GREEN
			;//               ||||PED.RED
			;//               |||PED.GREEN
			;//               ||BUZZ
			;//               |---
			;//               ---
			;
			;#pragma  bit RED       @ PORTA.0   
			;#pragma  bit YELLOW    @ PORTA.1   
			;#pragma  bit GREEN     @ PORTA.2   
			;#pragma  bit PED_GREEN @ PORTA.4   
			;#pragma  bit PED_RED   @ PORTA.3   
			;#pragma  bit BUZZ      @ PORTA.5   
			;
			;typedef unsigned char byte;
			;typedef unsigned long int LONG;
			;typedef bit BOOL;
			;
			;char GetOsccal();							// Defined at end of file
			;
			;#define NO_MCLR     &= ~0x80
			;#define CP_off      |= 0x2180
			;#pragma config  BODEN=off, NO_MCLR, PWRTE=on, FOSC=4, WDTE=off, CP_off
			;
			;void Delay100us (unsigned char aTs) // pause for aTs*100 us;
			;{ // 4+x*3 us = 4+3*32=100 us;
Delay100us
	MOVWF aTs
			; do  {
			;     char i = 33;            /* 2 IS */
m001	MOVLW .33
	MOVWF i
			;     do ; while ( --i > 0);  /* 26 * 3 - 1 = 77 IS */
m002	DECFSZ i,1
	GOTO  m002
			; } while ( --aTs > 0);         /* 3 IS */
	DECFSZ aTs,1
	GOTO  m001
			;}
	RETURN
			;
			;void DelayMs (unsigned char aTs) // pause for aTs*1 ms;
			;{
DelayMs
	MOVWF aTs_2
			; for (; aTs > 0; aTs--) {
m003	MOVF  aTs_2,1
	BTFSC 0x03,Zero_
	GOTO  m004
			;   clrwdt();
	CLRWDT
			;   Delay100us (10);
	MOVLW .10
	CALL  Delay100us
			; }
	DECF  aTs_2,1
	GOTO  m003
			;}
m004	RETURN
			;
			;void Delay10ms (byte aTs) // pause for aTs*10 ms;
			;{
Delay10ms
	MOVWF aTs_3
			; for (; aTs > 0; aTs--) {
m005	MOVF  aTs_3,1
	BTFSC 0x03,Zero_
	GOTO  m006
			;   Delay100us (100);
	MOVLW .100
	CALL  Delay100us
			; }
	DECF  aTs_3,1
	GOTO  m005
			;}
m006	RETURN
			;
			;
			;void main()
			;{
main
			;  W = GetOsccal();						// Set built-in oscillator calibration
	CALL  GetOsccal
			;  OSCCAL = W;
	BSF   0x03,RP0
	MOVWF OSCCAL
			;
			;    GIE = 0;                               
	BCF   0x0B,GIE
			;    GPIO = 0;                   //  Start with Everything Low
	BCF   0x03,RP0
	CLRF  GPIO
			;//    ANSEL = 0;                  //  Turn off ADC
			;    TRISIO= TrisA;                  //  All of GPIO are Outputs
	BSF   0x03,RP0
	CLRF  TRISIO
			;    CMCON = 0b.0000.0111; // comparator is turned off;
	MOVLW .7
	BCF   0x03,RP0
	MOVWF CMCON
			;    OPTION = 0;         
	BSF   0x03,RP0
	CLRF  OPTION_REG
			;
			;  while (1) {
			;
			;  RED=1;     
m007	BCF   0x03,RP0
	BSF   0x05,RED
			;  PED_GREEN=1;
	BSF   0x05,PED_GREEN
			;  Delay10ms(200);
	MOVLW .200
	CALL  Delay10ms
			;  Delay10ms(200);
	MOVLW .200
	CALL  Delay10ms
			;  RED=0;
	BCF   0x05,RED
			;  PED_GREEN=0;
	BCF   0x05,PED_GREEN
			;  PED_RED=1;
	BSF   0x05,PED_RED
			;  Delay10ms(20);
	MOVLW .20
	CALL  Delay10ms
			;  RED=1;
	BSF   0x05,RED
			;  Delay10ms(100);
	MOVLW .100
	CALL  Delay10ms
			;  RED=0;
	BCF   0x05,RED
			;
			;  GREEN=1;
	BSF   0x05,GREEN
			;  Delay10ms(200);
	MOVLW .200
	CALL  Delay10ms
			;  Delay10ms(200);
	MOVLW .200
	CALL  Delay10ms
			;  Delay10ms(200);
	MOVLW .200
	CALL  Delay10ms
			;  Delay10ms(200);
	MOVLW .200
	CALL  Delay10ms
			;  GREEN=0;
	BCF   0x05,GREEN
			;
			;  YELLOW=1;
	BSF   0x05,YELLOW
			;  Delay10ms(200);
	MOVLW .200
	CALL  Delay10ms
			;  YELLOW=0;
	BCF   0x05,YELLOW
			;
			;  }
	GOTO  m007
			;}
			;
			;#pragma origin 0x3FF
	ORG 0x03FF
			;// This is a dummy - actual procedure is preset in chip and will override
			;// A change of 1 causes about 1% change in frequency
			;char GetOsccal() {return 0x0;}
GetOsccal
	RETLW .0

	END


; *** KEY INFO ***

; 0x03FF    1 word(s)  0 % : GetOsccal
; 0x0001    8 word(s)  0 % : Delay100us
; 0x0009   10 word(s)  0 % : DelayMs
; 0x0013    9 word(s)  0 % : Delay10ms
; 0x001C   44 word(s)  4 % : main

; RAM usage: 3 bytes (3 local), 61 bytes free
; Maximum call level: 2
; Total of 73 code words (7 %)
